/*
    Chris Greco
    CIS 203 - Fall 2002
	
    Research Project - Shopping Aid Expert System
						for Choosing a Computer

    ***** Jaid (aid2) - Prolog with Amzi! and Java -  Version 2.0 ***** 
	  
    Jaid2.java - Expert system program
*/

import amzi.ls.*;                                       // Amzi! LogicServer
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

// Computer Shopping Program - Jaid 2.0
public class Jaid2 extends JFrame 
{ 
    // for display and layout
    private Container container;
    private GridBagLayout gbLayout;
    private GridBagConstraints gbConstraints; 
    JTextArea ta;                                       // question area
    static JComboBox cb;                                // choice combo box
    JPanel jp;                                          // display panal
    JButton b1, b2, b3;                                 // user control buttons
   
    private static LogicServer ls;                      // Logic Server
   
    // creates path for compiled Amzi! Prolog file ".xlp"
    final static String userDir = "C:\\AI\\Jaid2";
    final static String AIDXLP = userDir + "\\" + "aid2.xpl";
    
    // holds all of user's choices
    static Vector chosenOnes;                            
    // holds all choices for combo box
    static Vector choices;
    static int i = 0;                                   // counter for questions
    static int ri = -1;                                 // counter for recomend.
    
    String choice = null;                               // user's actual choice
    
    
    // All the choices String values
    // user types
    static String userChoices[] = {"Home", "Office", 
                         "Gamer", " ", " " };
    // number of programs running at once
    static String numberChoices[] = {"4 or less", "between 5 and 10", 
                         "more than 10", " ", " " };                     
    // processor types                        
    static String procChoices[] = {"Pentium 4", "Pentium 3", 
                         "Pentium Celeron", "AMD Athlon", "AMD Duron" };
    // memory sizes
    static String memChoices[] = {"64 MB", "128 MB", 
                         "256 MB", "512 MB", "1024 MB" };
    // what is it's uses
    static String whatChoices[] = {"Music", "Games", 
                      "Word Processing", "Development", "Simple Applications" };
    // hard disk capacity
    static String hdChoices[] = {"10 GB", "20 GB", 
                         "40 GB", "80 GB", "120 GB" };
    // case types
    static String caseChoices[] = {"Desktop", "Full tower", 
                         "Mid tower", "Mini tower", "Slimline" };
    // Operating Systems
    static String osChoices[] = {"Windows XP", "Windows ME", 
                         "Linux", " ", " " };
    // disk drive types
    static String driveChoices[] = {"DVD-ReWritable", "DVD", 
                         "CD-ReWritable", "CD-ROM", " " };
    // video card types
    static String videoChoices[] = {"32 MB", "64 MB", 
                         "128 MB", " ", " " };
    // monitor sizes
    static String monChoices[] = {"15 inches", "17 inches", 
                         "19 inches", "20 inches", " " };
    // printer types
    static String priChoices[] = {"Color Inkjet", "Photo Inkjet", 
                         "Fax-Printer Combonation", "Laser", "None for now" };
    // internet choices
    static String intChoices[] = {"Modem-Dialup (cheaper)", "Cable (faster)", 
                         "DSL (faster)", "None for now", " " };
    
                         
    // All the question String values
    static String questions[] = {
                                // user type 
                                "Computer Shopping Aid, Java Enhanced, Version (2.0)\n" +
                                "Created by Chris Greco\n" +
                                "     using Java, Prolog, and the Amzi! Logic Server\n"+ 
                                "----------------------------------------" + 
                                "----------------------------------\n\n\n" +
                                "The first thing you need to know when choosing a computer\n" +
                                "     is what type of user you are,\n\n" +
                                "Home user \t -> general purpose user\n" +
                                "Office user \t -> no top of the line models\n" +
                                "Gamer \t -> nothing but the best\n", 
                                
                                // number of programs running at once
                                "Next, how many programs do you usually run at once,\n\n" +
                                "4 or less \t\t - not much power needed\n" +
                                "between 5 and 10 \t - average computer user\n" +
                                "more than 10 \t\t - very interesting people\n",
                                
                                
                                // processor types
                                "So far, so good, \n" + 
                                "     time to choose your processor,\n\n" +
                                "more than 10:\n" + 
                                "     Consider the Pentium 4 or AMD Athlon\n" + 
                                "between 5 and 6:\n" + 
                                "     Consider the Pentium 3 or AMD Athlon\n" +
                                "4 or less:\n" +
                                "     Consider the Pentium 3, Celeron, AMD Duron\n",
                                
                                // memory sizes
                                "Ok, you must choose your memory.\n\n" +
                                "The more memory you have\n" +
                                "\t the faster your computer will run (hopefully...):\n\n" +
                                "Pentium 4, Pentium 3, and AMD Athlon:\n" +
                                "\t between 256 and 1024 MegaBytes\n" +
                                "Celeron and AMD Duron:\n" +
                                "\t between 64 and 256 MegaBytes\n",
                                
                                // what is it's uses
                                "Personal Question:\n" +
                                "     What do you mostly use your computer for?\n\n" +
                                "Music       \t\t - Downloading and/or listening\n" +
                                "Games       \t\t - Playing games\n" +
                                "Word Processing \t - Writing and reading documents\n" +
                                "Development \t\t - Programming and Design\n" +
                                "Simple Apps \t\t - Simple/basic applications\n",
                                
                                // hard disk capacity
                                "Now based on what you just chose,\n" +
                                "     choose a hard disk drive:\n\n" +
                                "Music, Games, and/or Development may want more capacity\n" +
                                "     between 80 and 120 GigaBytes\n" +
                                "Word Processing and Simple Applications need less capicity\n" +
                                "     between 10 and 40 GigaBytes\n",
                                
                                // case types
                                "Personal Opinion Question:\n" +
                                "     Which case do you prefer'\n\n" +
                                "Desktop \t - sits on the desk under the monitor (outdated)\n" +
                                "Full Tower \t - stands tall with more ports (expantion)\n" +
                                "Mid Tower \t - stands the average size (most common)\n" +
                                "Mini Tower \t - stands smaller than average\n" +
                                "Slimline \t - new and very small (not very expandable)\n",
                                
                                // Operating Systems
                                "Time to choose your Operating System,\n" +
                                "     You wouldn't go far without it.\n\n" +
                                "Both Gamers and Home users should go with Windows\n" +
                                "     XP for expereinced users\n" +
                                "     ME for non-experienced users\n\n" +
                                "Developers might prefer Linux\n",
                                
                                // disk drive types
                                "It is a neccessary that you choose a disk drive.\n\n" +
                                "Pentium 4 and AMD Athlon users should choose:\n" +
                                "     DVD and/or CD, so choose anything you want\n\n" +
                                "Everyone else better choose CD-RW or CD-ROM\n",
                                
                                // video card types
                                "Ok, now we will choose your video card (graphics card),\n" +
                                "     then we will choose your monitor\n\n" +
                                "Gamers need the most video memory (MegaBytes)\n" +
                                "Home users probably don't need anything too fancy\n" +
                                "Office users need only the basics (lowest MegaBytes)\n",
                                
                                // monitor sizes
                                "And now your monitor,\n\n" +
                                "15  through 20 inches,\n" +
                                "     this one is all up to you, but remember,\n" +
                                "     bigger is always better!\n",
                                
                                // printer types
                                "Some People would also like a printer,\n" +
                                "\t but if not just choose none for now.\n\n" +
                                "Color Inkjets are the most common household printers\n" +
                                "Photo Inkjets are for printing photographic quality\n" +
                                "Fax-Printer Combos are nice for the office\n" +
                                "Laser Printers are for major printing jobs,\n" +
                                "\t and also have the best quality and are most expensive\n",
                                
                                // internet choices
                                "Last thing you need to do now is\n" +
                                "     choose how you want to acces the interent,\n" +
                                "\t if not you're not ready just choose none for now.\n\n" +
                                "Modem-Dial-up \t - cheaper and slower over the phone line\n" +
                                "Cable        \t\t - much faster than Dial-up\n" +
                                "DSL          \t\t - similar in performance to Cable\n"
    };
   
   
    // each choice is checked in Prologs database using these Strings
    static String links[] = {"userNeeds('",
                            "numberNeeds('",
                            "cpuNeeds('",
                            "memNeeds('",
                            "whatNeeds('",
                            "hdNeeds('",
                            "caseNeeds('",
                            "osNeeds('",
                            "driveNeeds('",
                            "vcNeeds('",
                            "monNeeds('",
                            "priNeeds('",
                            "intNeeds('"};
                            
    // all reccomendations work with these Strings which are subStrings
    //   of a Prolog predicate name
    static String reccs[] = {"Proc", "Mem", "HD", "Case", "OS", "Drive", "Vid", "Mon",
                            "Pri", "Int" };
                              
                          
    // Global Jaid2
    static Jaid2 gbd;
   
    // starts the program, stays true to aid 1.0's way of using startAid
    public static void aid()
    {
        // Displays a splash screen
        xPopup spl = new xPopup(userDir + "\\" + "Jsplash.jpg");
        spl.set("Jaid  -  aid([2.0])", "Computer Shopping Aid", " made possible by Java and Amzi!",
                "Version 2.0", "Created by Chris Greco");
        spl.run() ;
        spl.setVisible(true) ;

        // wait 6 seconds before remove splash screen
        spl.hide(6);
        spl.dispose();
       
        // displays intro window
        JOptionPane.showMessageDialog(null,
                "          So you want to buy a computer,\n" + 
                "      you have come to the right program.\n\n",
                "Computer Shopping Aid", JOptionPane.PLAIN_MESSAGE);
        
        // sets up a new vector of choices for combo boxes
        choices = new Vector();
        choices.add(0, userChoices);
        choices.add(1, numberChoices);
        choices.add(2, procChoices);
        choices.add(3, memChoices);
        choices.add(4, whatChoices);
        choices.add(5, hdChoices);
        choices.add(6, caseChoices);
        choices.add(7, osChoices);
        choices.add(8, driveChoices);
        choices.add(9, videoChoices);
        choices.add(10, monChoices);
        choices.add(11, priChoices);
        choices.add(12, intChoices);
        
        // sets up a new blank vector, size of choices, for user choices
        chosenOnes = new Vector(choices.size());
        
        // Must either throw LSException or catch LSException
        //  when using the Amzi! LogicServer
        //      System must exit if LogicServer fails
        try {
                // sets up, initializes, and loads compiled Prolog file ".xlp"
                ls = new LogicServer();
                ls.Init("");
                ls.Load(AIDXLP);
        }
        catch (LSException lsex) {
                JOptionPane.showMessageDialog(null,
                    "Amzi! LogicServer failed!\n",
                    "Computer Shopping Aid", JOptionPane.ERROR_MESSAGE);
                try {
                    ls.Close();
                }
                catch (LSException lsex2) {
                    System.exit(0);
            }     
                System.exit(0);
        }      
        
        // sets up Jaid2 with windowlistener
        gbd = new Jaid2(questions[i], (String[])choices.get(i), links[i]);
        gbd.setResizable(false);
        gbd.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent wine) {
                  System.exit(0); 
            }});
    }
    
    public Jaid2(final String text, final String[] names, final String nextLink)
    {
        super( "Computer Shopping Aid" );

        // for combo box
        Icon icons[] = { new ImageIcon ( names[0] ),
                        new ImageIcon ( names[1] ),
                        new ImageIcon ( names[2] ),
                        new ImageIcon ( names[3] ),
                        new ImageIcon ( names[4] )   };
      
        // for display and layout
        container = getContentPane();
        gbLayout = new GridBagLayout();
        container.setLayout( gbLayout );   

        // instantiate gridbag constraints
        gbConstraints = new GridBagConstraints();
        // anchor for all components is CENTER: the default
      
        // text area
        ta = new JTextArea( text, 15, 40 );
        ta.setEditable(false);    
        jp = new JPanel();
        jp.add(ta);
        gbConstraints.weightx = 10;   // can grow wider
        gbConstraints.weighty = 10;   // can grow taller
        gbConstraints.fill = GridBagConstraints.BOTH;
        addComponent( jp, 0, 0, 4, 1 );  

        // combo box  
        cb = new JComboBox( names );
      
        gbConstraints.fill = GridBagConstraints.NONE;     // set fill back to none
        gbConstraints.weightx = 3;                        // can grow wider
        gbConstraints.weighty = 3;                        // can grow taller
        addComponent( cb, 2, 1, 1, 1 );             

        // Next button b1
        b1 = new JButton( "Next");
        gbConstraints.weightx = 1;  
        gbConstraints.weighty = 1;    
        addComponent( b1, 3, 2, 1, 1 );
      
        // Quit button b2
        b2 = new JButton( "Quit" );
        gbConstraints.weightx = 1;
        gbConstraints.weighty = 1;    
        addComponent( b2, 3, 3, 1, 1 );
      
        // Recommendation button b3
        //    exists on every question except for questions 1, 2, 5, 12
        b3 = new JButton( "Recommendation" );
        gbConstraints.weightx = 1;
        gbConstraints.weighty = 1;    
        if (i >= 2 && i != 4 && i <= 11) {
            addComponent( b3, 3, 1, 1, 1 );
            ri++;
        }
   
        // create an instance of inner class ButtonHandler
        // to use for button event handling 
        ButtonHandler handler = new ButtonHandler();
        b1.addActionListener( handler );
        b2.addActionListener( handler );
        b3.addActionListener( handler );

        setSize( 500, 350 );
        show();
    }
   
    // addComponent is programmer defined
    private void addComponent( Component c,
        int row, int column, int width, int height )
    {
        // set gridx and gridy 
        gbConstraints.gridx = column;
        gbConstraints.gridy = row;

        // set gridwidth and gridheight
        gbConstraints.gridwidth = width;   
        gbConstraints.gridheight = height;

        // set constraints
        gbLayout.setConstraints( c, gbConstraints );  
        container.add( c );      // add component 
    }

    // inner class for button event handling
    private class ButtonHandler implements ActionListener {
        public void actionPerformed( ActionEvent e )
        {
            // Quit button simply exits if Yes, returns to program if No
            if ( e.getActionCommand() == "Quit" ) {
                Object options[] = {"Yes", "No"};
                int choice = JOptionPane.showOptionDialog(null,
                        "You really want to quit?",
                        "Quit?", 2,
                        JOptionPane.ERROR_MESSAGE,
                        null, options, options[0]);  
                if (choice == 0)
                    System.exit(0);
            }
            
            // Next button
            else if ( e.getActionCommand() == "Next" ) {
                // if combo box has blank, return to avoid database error
                if (cb.getSelectedItem().toString().compareTo(" ") == 0)
                    return;
                // display what user has chosen
                JOptionPane.showMessageDialog( null, 
                        "You have chosen:    " 
                        + cb.getSelectedItem().toString(),
                        "Next Question",
                        JOptionPane.PLAIN_MESSAGE);
                // add the choice to the vector chosenOnes
                chosenOnes.add(i, cb.getSelectedItem().toString());
                // call Prolog database to ensure choice exists
                //  **************************************************
                //  * ls.CallStr(s) simply looks for String s inside *
                //  *   of the Prolog code.  If that string exists   *
                //  *   and works then a long term is returned.      *
                //  *   long term is Amzi's coded return values      *
                //  *   If String s does not exist, then term = 0    *
                //  * ls.GetStrArg(term, 1) simply decodes Amzi's    *
                //  *   long term, and finds the return value of the *
                //  *   first parameter                              *
                //  **************************************************
                try {
                    // calls Prolog functions/predicates using Amzi! LogicServer
                    long term = ls.CallStr(links[i] + chosenOnes.get(i) + "')");
                    String return1 = ls.GetStrArg(term, 1); // return values
                }
                catch (LSException lsex) {
                    JOptionPane.showMessageDialog(null,
                            "Amzi! LogicServer failed!\n",
                            "Computer Shopping Aid", JOptionPane.ERROR_MESSAGE);
                    try {
                        ls.Close();
                    }
                    catch (LSException lsex2) {
                        System.exit(0);
                    }     
                    System.exit(0);
                }      
        
                // hide current window
                gbd.setVisible(false);
            
                // increment counter to advance questions and choices
                i++;
            
                // checks for end of questions
                if (i < choices.size()) {
                    // sets up new Jaid2 with windowlistener 
                    gbd = new Jaid2(questions[i], (String[])choices.get(i),
                                                                    links[i]);
                    gbd.setResizable(false);
                    gbd.addWindowListener(new WindowAdapter() {
                    public void windowClosing(WindowEvent wine) {
                        System.exit(0);
                    }});
                }
                // displays results
                else
                {
                    Object options[] = {"View Results"};
                    int choice = JOptionPane.showOptionDialog(null,
                        "You have completed this program\nThank you for your time",
                        "Done!", 1,
                        JOptionPane.PLAIN_MESSAGE,
                        null, options, options[0]);   // both buttons work
                
                    int j = 5;
                    String results = "  Wow, you did it!\n" +
                                 "  You created your own " + chosenOnes.get(j - 5) + " computer, \n\n" +
                                 "  Processor \t\t - " + chosenOnes.get(j - 3) + "  \n" +
                                 "  Memory \t\t - " + chosenOnes.get(j - 2) + "  \n" +
                                 "  Hard Disk Capacity \t - " + chosenOnes.get(j++) + "  \n" +
                                 "  Case Style \t\t - " + chosenOnes.get(j++) + "  \n" +
                                 "  Operating System: \t - " + chosenOnes.get(j++) + "  \n" +
                                 "  Disk Drive \t\t - " + chosenOnes.get(j++) + "  \n" +
                                 "  Video Card \t\t - " + chosenOnes.get(j++) + "  \n" +
                                 "  Monitor \t\t - " + chosenOnes.get(j++) + "  \n" +
                                 "  Printer \t\t - " + chosenOnes.get(j++) + "  \n" +
                                 "  Internet \t\t - " + chosenOnes.get(j++) + "  \n";
                                 
                    // text area
                    JTextArea tb = new JTextArea(results );
                    tb.setEditable(false);
                
                    // window for user's chosenOnes list
                    JFrame checkedWindow = new JFrame("Here is your computer...");
                    checkedWindow.addWindowListener(new WindowAdapter() {
                            public void windowClosing(WindowEvent wine) {
                                System.exit(0); }});
                    checkedWindow.setSize(360, 300);
                    checkedWindow.setResizable(false);
                       
                    Container wow = checkedWindow.getContentPane();
                    wow.setLayout(new FlowLayout(FlowLayout.CENTER));
                    wow.add(new JScrollPane(tb));

                    checkedWindow.setVisible(true);    
                }
            }
          
            // ***** THE RECOMMENDATION BUTTON *****
            //    Uses Amzi and Prolog in an AI style to query the database
            //        retrieves advice from the expert system
            if ( e.getActionCommand() == "Reccomendation" ) {
                String firstArg = null;
                // setup of questions calls for this
                // get the last choice
                if (i == 2 || i == 5)                     
                    firstArg = (String)chosenOnes.get(i - 1);
                // get the user type choice
                else if (i == 3 || i == 7 || i == 9 || i == 10)
                    firstArg = (String)chosenOnes.get(i - i);
                // get the current selected combo box choice
                else if (i == 6 || i == 11)
                    firstArg = cb.getSelectedItem().toString();
                // get the processor type for disk drive compatiblity
                else if (i == 8)
                    firstArg = (String)chosenOnes.get(i - 6);
                String secArg = cb.getSelectedItem().toString();
                
                // calls Prolog functions/predicates using Amzi! LogicServer
                //  checks for a recommendation, return value is a 
                //  String that will be outputted in a JOptionPane window
                try {
                    long term = ls.CallStr("check" + reccs[ri] + "('" +
                                        firstArg + "','" +
                                        secArg + "', X)");
                    // suggestion is the returned String (ls.GetStrArg)
                    String suggestion = ls.GetStrArg(term, 3);
                    JOptionPane.showMessageDialog(null, 
                        suggestion,
                        "Computer Shopping Aid", JOptionPane.WARNING_MESSAGE);
                }
                catch (LSException lsex3) {
                    JOptionPane.showMessageDialog(null, 
                    "Sorry, no reccomendation at this time",
                    "Computer Shopping Aid", JOptionPane.WARNING_MESSAGE);
                }
          }
      }
   }
   
   public static void main(String args[])
   {
       // aid([2.0])
       // starts the program, stays true to aid 1.0's way of using startAid
       aid();                                           // remember aid([])
   }
}