/*
	Chris Greco
	CIS 203 - Fall 2002
	
	Research Project - Shopping Aid Expert System
						for Choosing a Computer

	***** Jaid (aid2) - Prolog with Amzi! and Java -  Version 2.0 ***** 
	  
	aid2.pro - Expert system program
*/


/******************************************************************************
	Brief explanation of Shopping Aid program flow
*******************************************************************************
	
	This version of Computer Shopping Aid works with Java and Amzi!.
	You must compile and link this file into "aid2.xpl"
	Then as long as that Jaid2 knows where that file is, Java
		should have no problem launching Jaid - Computer Shopping Aid.
	If the program is looking for a ".jpg" then that has nothing to do
		with Amzi or Prolog and just has to be there for a splash
		screen, but most likely any jpeg named "Jsplash.jpg" will work.	
*/



/******************************************************************************
	Types of available computer parts and information
******************************************************************************/

userNeeds('Home').						% user types
userNeeds('Office').
userNeeds('Gamer').
numberNeeds('4 or less').					% number of processes running
numberNeeds('between 5 and 10').
numberNeeds('more than 10').
cpuNeeds('Pentium 4').						% processor types
cpuNeeds('Pentium 3').
cpuNeeds('Pentium Celeron').
cpuNeeds('AMD Athlon').
cpuNeeds('AMD Duron').
memNeeds('64 MB').						% memory amounts
memNeeds('128 MB').
memNeeds('256 MB').
memNeeds('512 MB').
memNeeds('1024 MB').
whatNeeds('Music').						% what is its use
whatNeeds('Games').
whatNeeds('Word Processing').
whatNeeds('Development').
whatNeeds('Simple Applications').
hdNeeds('10 GB').							% hard disk capacities
hdNeeds('20 GB').
hdNeeds('40 GB').
hdNeeds('80 GB').
hdNeeds('120 GB').
caseNeeds('Desktop').						% case styles
caseNeeds('Full tower').
caseNeeds('Mid tower'). 
caseNeeds('Mini tower').
caseNeeds('Slimline').
osNeeds('Windows XP').						% typical operating systems
osNeeds('Windows ME').
osNeeds('Linux').
vcNeeds('32 MB').							% video card types
vcNeeds('64 MB').
vcNeeds('128 MB').
driveNeeds('DVD-ReWritable').					% drives available
driveNeeds('DVD').
driveNeeds('CD-ReWritable').
driveNeeds('CD-ROM').
monNeeds('15 inches').						% typical monitor sizes
monNeeds('17 inches').
monNeeds('19 inches').
monNeeds('20 inches').
priNeeds('None for now').					% printer types
priNeeds('Color Inkjet').
priNeeds('Photo Inkjet').
priNeeds('Fax-Printer Combonation').
priNeeds('Laser').
intNeeds('None for now').					% internet options
intNeeds('Modem-Dialup (cheaper)').
intNeeds('Cable (faster)').
intNeeds('DSL (faster)').


/******************************************************************************
	Requirements for certain components
******************************************************************************/

procReq('more than 10', 'Pentium 4').
procReq('more than 10', 'AMD Athlon').
procReq('between 5 and 10', 'Pentium 4').
procReq('between 5 and 10', 'AMD Athlon').
procReq('between 5 and 10', 'Pentium 3').
procReq('4 or less', 'Pentium 4').
procReq('4 or less', 'AMD Athlon').
procReq('4 or less', 'Pentium 3').
procReq('4 or less', 'Pentium Celeron').
procReq('4 or less', 'AMD Duron').

memReq('Home', '256 MB').
memReq('Home', '512 MB').
memReq('Home', '1024 MB').
memReq('Office', '64 MB').
memReq('Office', '128 MB').
memReq('Office', '256 MB').
memReq('Office', '512 MB').
memReq('Office', '1024 MB').
memReq('Gamer', '512 MB').
memReq('Gamer', '1024 MB').

hdReq('Music', '40 GB').
hdReq('Music', '80 GB').
hdReq('Music', '120 GB').
hdReq('Games', '80 GB').
hdReq('Games', '120 GB').
hdReq('Word Processing', '10 GB').
hdReq('Word Processing', '20 GB').
hdReq('Word Processing', '40 GB').
hdReq('Development', '40 GB').
hdReq('Development', '80 GB').
hdReq('Development', '120 GB').
hdReq('Simple Applications', '10 GB').
hdReq('Simple Applications', '20 GB').
hdReq('Simple Applications', '40 GB').

caseReq('Desktop').
caseReq('Full tower').
caseReq('Mid tower').

osReq('Home', 'Linux').
osReq('Office', 'Linux').
osReq('Gamer', 'Linux').

driveReq('Pentium 4', 'DVD').
driveReq('Pentium 4', 'DVD-ReWritable').
driveReq('Pentium 4', 'CD-ReWritable').
driveReq('AMD Athlon', 'DVD').
driveReq('AMD Athlon', 'DVD-ReWritable').
driveReq('AMD Athlon', 'CD-ReWritable').
driveReq('Pentium 3', 'DVD').
driveReq('Pentium 3', 'CD-ReWritable').
driveReq('Pentium Celeron', 'CD-Rewritable').
driveReq('Pentium Celeron', 'CD-ROM').
driveReq('AMD Duron', 'CD-Rewritable').
driveReq('AMD Duron', 'CD-ROM').

videoReq('Home', '32 MB').
videoReq('Home', '64 MB').
videoReq('Home', '128 MB').
videoReq('Office', '32 MB').
videoReq('Office', '64 MB').
videoReq('Gamer', '128 MB').

monReq('Home', '15 inches').
monReq('Home', '17 inches').
monReq('Home', '19 inches').
monReq('Home', '20 inches').
monReq('Office', '15 inches').
monReq('Office', '17 inches').
monReq('Office', '19 inches').
monReq('Gamer', '19 inches').
monReq('Gamer', '20 inches').

priReq('Color Inkjet').
priReq('Photo Inkjet').
priReq('Fax-Printer Combonation').
priReq('Laser').
 

/******************************************************************************
	Shopping Aid 
		Reccomendation program 
******************************************************************************/

% checks number of programs and processor
checkProc(N, P, X)	:-      (procReq(N, P), X = 'You have made a fine choice');
				X = 'Your processor may not be powerful enough to support or number of programs'.
		
& checks user type and memory 
checkMem(U, M, X)	:-	(memReq(U, M), X = 'You have made a fine choice');
				X = 'Your computer really should have more memory'.

% checks computer's use and hard disk capacity
checkHD(W, HD, X)	:-	(hdReq(W, HD), X = 'You have made a fine choice');
				((W == 'Word Processing'; W == 'Simple Applications'),
					X = 'Your computer probably does not need so much space');
				X = 'This capacity may not be enough for your needs'.

% gives information on case types
checkCase(C, N, X)	:-	(caseReq(C), X = 'This case is expandable and upgradable');
				X = 'This case is small but is more difficult and expensive to upgrade'.

% checks user type and operating systems
checkOS(U, OS, X)	:-	(osReq(U, OS), X = 'Linux might be more difficult for you to use');
				X = 'Windows XP and ME are the most common operating systems'.

% checks processor with disk drive compatability
checkDrive(P, D, X)	:-	(driveReq(P, D), X = 'You have made a fine choice');
				((D == 'CD-ROM'),
					X = 'You could do much better than a basic CD-ROM');
				X = 'Your processor might not be powerful enough for a DVD'.

% checks user type with video card type
checkVid(U, V, X)	:-	(videoReq(U, V), X = 'You have made a fine choice');
				((V == '128 MB'),
					X = 'An office computer might not require the need for such power');
				X = 'Any real gamer should have more graphic power than that'.

% checks user type with monitor size
checkMon(U, Mon, X)	:-	(monReq(U, Mon), X = 'You have made a fine choice');
				((Mon == '20 inches'),
					X = 'An office computer might not require such a large monitor');
				X = 'Any real gamer should have more a decent sized monitor'.	

% gives information on printer types
checkPri(Pri, N, X)	:-	priReq(Pri),
				((Pri == 'Color Inkjet'; Pri == 'Photo Inkjet'),
					X = 'Inkjet Printers are the most common printers, Photo has better quality');
				((Pri == 'Fax-Printer Combonation'),
					X = 'Fax-Printer Combos are good for the office or to save desk space');
				((Pri == 'Laser'),
					X = 'Laser Printers are the most expensive, but have high page output');
				X = 'It is okay, you can decide later'.	