/*
    Chris Greco
    CIS 203 - Fall 2002
	
    Research Project - Shopping Aid Expert System
						for Choosing a Computer

    ***** Jaid (aid2) - Prolog with Amzi! and Java -  Version 2.0 ***** 
	  
    xPopup.java - Splash Screen class
*/

import java.awt.*;

public class xPopup extends Window
{
    int width = 50, height = 50;

    Image tile = null;
    Toolkit toolkit = Toolkit.getDefaultToolkit() ;

    String name    = " " ;
    String version = " " ;
    String author  = " " ;
    String web     = " " ;
    String mail    = " " ;

    // Constructor, default splash is Jaid's Jsplash
    xPopup()
    {
       super(new Frame());
       setVisible(false) ;

       charge("Jsplash.jpg") ;
    }

    // Constructor, with alternate splash
    xPopup(String s)
    {
       super(new Frame());
       setVisible(false) ;

       charge(s) ;
    }
    
    // sets up the bottom-right information box
    public void set(String name, String version, String author, String web, String mail) {
      this.name = name ;
      this.version = version ;
      this.author = author ;
      this.web = web ;
      this.mail = mail ;
    }
    
    // sets up media
    private void charge(String s)
    {
          MediaTracker trk = new MediaTracker(this) ;
          tile = toolkit.getImage( s );
          if (tile != null) {
              trk.addImage(tile, 0) ;

              try	{	trk.waitForID(0) ;	}
              catch ( InterruptedException e) {  }

              setSize(tile.getWidth(this), tile.getHeight(this)) ;
          }
    }

    // runs
    public void run( ) {
          init() ;
    }
    // initializes location
    public void init( )
    {
        Dimension dS = Toolkit.getDefaultToolkit().getScreenSize() ;
        Dimension dL = getSize() ;

        if (dL.width > dS.width) dL.width = dS.width ;
        if (dL.height > dS.height) dL.height = dS.height ;

        setLocation ( (dS.width - dL.width) / 2 , (dS.height - dL.height) / 2) ;
        if(tile != null)
            setVisible(true) ;
    }

    // hides after a period of time
    public void hide(int i) {
        try {
            Thread.sleep(i * 1000) ;
        }
        catch (Exception e) { }

        setVisible(false) ;
    }

    // displays all
    public void paint(Graphics g)
    {
          int width = getSize().width, height = getSize().height, x = 0, y = 0;

          if(tile != null)
            g.drawImage(tile, 0, 0, getBackground(), this);

          g.setColor(new Color(0xD0D0D0)) ;
          g.fill3DRect(width-245, height-200, 225, 180, true);
          g.setColor(new Color(0x0)) ;
          g.draw3DRect(width-245, height-200, 225, 180, true);

          Font f = this.getFont() ;

          if (name != null) {
            g.setFont(new Font("System",3, 18)) ;
            g.drawString(name, width-230, height-175) ;
          }

          int Y = height-150 ;
          g.setFont(f) ;
          if (version != null) {
            //g.drawString("", width-235, Y) ;
            g.drawString(version, width-230, Y) ;
            Y += 22 ;
          }
          if (author != null) {
           // g.drawString("", width-235, Y) ;
            g.drawString("  built using Java and Prolog", width-230, Y) ;
            Y += 22 ;
          }
          if (web != null) {
            //g.drawString("Version", width-235, Y) ;
            g.drawString("    with the Amzi! Logic Server", width-230, Y) ;
            Y += 22 ;
          }
          if (mail != null) {
           // g.drawString("Author", width-235, Y) ;
            g.drawString(web, width-230, Y) ;
            Y += 22 ;
          }
           
          if (mail != null) {
           // g.drawString("Author", width-235, Y) ;
            g.drawString(mail, width-230, Y) ;
            Y += 22 ;
          }
    }
}
